---
title: "Arbres"
date: "2022-02-23"
patat:
  eval:
    tai:
      command: fish
      fragment: false
      replace: true
    ccc:
      command: fish
      fragment: false
      replace: true
  images:
    backend: auto
...

# Les arbres: définition

"Un arbre est un graphe acyclique orienté possédant une unique racine, et tel que tous les nœuds sauf la racine ont un unique parent."

. . .

**Santé!**

## Plus sérieusement

* Ensemble de **noeuds** et d'**arêtes** (graphe),
* Les arêtes relient les noeuds entre eux, mais pas n'importe comment: chaque
  noeud a au plus un **parent**,
* Le seul noeud sans parent est la **racine**,
* Chaque noeud a un nombre fini de **fils**,
* La hiérarchie des noeuds rend les arêtes **orientées** (parent -> fils), et empêche les
  **cycles** (acyclique, orienté).
* La **feuille** ou **noeud terminal** est un noeud sans enfants,
* Le **niveau** est 1 à la racine et **niveau+1** pour les fils,
* Le **degré** d'un noeud est le nombre de fils du noeud.

# Arbre ou pas arbre?

::: columns

:::: column
```{.mermaid format=pdf width=300 loc=figs/}
graph TD;
    1-->2;
    1-->3;
    3-->2;
    3-->4;
    3-->5;
```
::::

. . .

:::: column
```{.mermaid format=pdf width=300 loc=figs/}
graph TD;
    1-->2;
    1-->3;
    3-->4;
    3-->5;
    3-->6;
```
::::

:::

# Arbre ou pas arbre?

::: columns

:::: column
```{.mermaid format=pdf width=300 loc=figs/}
graph TD;
    1-->2;
    1-->3;
    3-->4;
    3-->5;
    3-->6;
    6-->7;
    7-->3;
```
::::

. . .

:::: column
```{.mermaid format=pdf width=300 loc=figs/}
graph TD;
    1;
```
::::

:::

# Arbre ou pas arbre?

::: columns

:::: column
```{.mermaid format=pdf width=300 loc=figs/}
graph TD;
    1---2;
    1---3;
    3---4;
    3---5;
```
::::

. . .

:::: column
```{.mermaid format=pdf width=300 loc=figs/}
graph BT;
    1-->2;
    1-->3;
    3-->4;
    3-->5;
    3-->6;
```
::::

:::

# Degré et niveau

* Illustration du degré (nombre de fils) et du niveau (profondeur)

::: columns

:::: column
```{.mermaid format=pdf width=300 loc=figs/}
graph TD;
    1[degré 2]-->2[degré 0];
    1-->3[degré 3];
    3-->4[degré 0];
    3-->5[degré 0];
    3-->6[degré 0];
```
::::

. . .

:::: column
```{.mermaid format=pdf width=300 loc=figs/}
graph TD;
    1[niveau 1]-->2[niveau 2];
    1-->3[niveau 2];
    3-->4[niveau 3];
    3-->5[niveau 3];
    3-->6[niveau 3];
```
::::

:::

* Les noeuds de degré 0, sont des feuilles.

# Application: recherche rapide

* Le nombre secret ou la recherche dychotomique (nombre entre 0 et 10).

```{.mermaid format=pdf width=300 loc=figs/}
graph LR;
    5-->2;
    5-->7;
    7-->8;
    7-->6;
    8-->9;
    9-->10;
    2-->1;
    2-->3;
    3-->4;
    1-->0;
```
